/** 
 * ******************************************************************************
 * \file		buttons_task.c
 * \date		:  15 . 2021 .
 * \version		0.0a
 * \author		
 * 
 * ----------------------------------------------------------------------------
 * \brief		 "".
 * \details		 ,  , 
 * 				    ""
 * ******************************************************************************
 */


/*
 * ============================================================================
 *   Includes
 * ============================================================================
 */
#include "buttons_task.h"
/*--- [Std lib] -------------------------*/
#include <stdint.h>
#include <stdlib.h>

/*--- [System Level] --------------------*/

/*--- [RTOS Level] ----------------------*/
#include "FreeRTOS.h"
#include "task.h"
#include "queue.h"
#include "semphr.h"
/*--- [Driver Level] --------------------*/
#include "../Drivers/Buttons/buttons_drv.h"
/*
 * ============================================================================
 *   Declarations
 * ============================================================================
 */
/*---------------------------------------------------------
 * 	[Types]
 */
/*---------------------------------------------------------
 * 	[Structs, Enums]
 */
/*---------------------------------------------------------
 *  [Defines]
 */
/*---------------------------------------------------------
 *  [Macros]
 */
/*---------------------------------------------------------
 *  [Private (static) variables]
 */
/*---------------------------------------------------------
 *  [Global variables]
 */
/*---------------------------------------------------------
 *  [External variables]
 */
extern TaskHandle_t pxMotor;
/*---------------------------------------------------------
 *  [External function prototipes]
 */

/*
 * ============================================================================
 *
 *   Private (Static) functions
 *
 * ============================================================================
 */


/*
 * ============================================================================
 *
 *   Public (Global) functions
 *
 * ============================================================================
 */
/** @{ */

/** -------------------------------------------------------
 * \brief ,   "Buttons"
 * \param *pvParameters -    
 */
void prvButton(void *pvParameters)
{
	btn_t kbd = {0, 0};
	uint8_t flag;
	uint32_t command = 0;

	/*   */
	for(;;)
	{
		/*      */
		flag = ButtonsRead(&kbd);

		/*     ,
		 *      
		 *      "Motor"
		 */
		if(flag)
		{
			command = 0;
			if(kbd.btn1 == BTN_PRESS) command = 1;
			if(kbd.btn2 == BTN_PRESS) command = 2;
			if((kbd.btn1 == BTN_PRESS)&&(kbd.btn2 == BTN_PRESS))
				command = 3;

			xTaskNotify(pxMotor, 			//   "Motor"
					command, 				//  
					eSetValueWithOverwrite);//     
		}

		/*  (Blocked)    2  */
		vTaskDelay(pdMS_TO_TICKS(2));

	}
}//--------------------------------------------------------

/** @} */
/*==== END FILE =============================================================*/
