/** 
 * ******************************************************************************
 * \file		extctrl_task
 * \date		:  15 . 2021 .
 * \version		0.0a
 * \author		
 * 
 * ----------------------------------------------------------------------------
 * \brief		 " "
 * \details		
 *              
 * \attention	  .     !
 * ******************************************************************************
 */


/*
 * ============================================================================
 *   Includes
 * ============================================================================
 */
#include "extctrl_task.h"
/*--- [Std lib] -------------------------*/
#include <stdint.h>
#include <stdlib.h>

/*--- [System Level] --------------------*/

/*--- [RTOS Level] ----------------------*/
#include "FreeRTOS.h"
#include "task.h"
#include "queue.h"
#include "semphr.h"

/*--- [Driver Level] --------------------*/

/*
 * ============================================================================
 *   Declarations
 * ============================================================================
 */
/*---------------------------------------------------------
 * 	[Types]
 */
/*---------------------------------------------------------
 * 	[Structs, Enums]
 */
/*---------------------------------------------------------
 *  [Defines]
 */
/*---------------------------------------------------------
 *  [Macros]
 */
/*---------------------------------------------------------
 *  [Private (static) variables]
 */
/*---------------------------------------------------------
 *  [External variables]
 */
extern TaskHandle_t pxMotor;
/*---------------------------------------------------------
 *  [Global variables]
 */
/*---------------------------------------------------------
 *  [External function prototipes]
 */

/*
 * ============================================================================
 *
 *   Private (Static) functions
 *
 * ============================================================================
 */


/*
 * ============================================================================
 *
 *   Public (Global) functions
 *
 * ============================================================================
 */
/** @{ */

/** -------------------------------------------------------
 * \brief ,   "External Control"
 * \param *pvParameters -    
 *
 * \attention    .
 *                 !
 */
void prvExtConlrol(void *pvParameters)
{

	/*   */
	for(;;)
	{

		vTaskDelay(pdMS_TO_TICKS(10000));
		xTaskNotify(pxMotor, 				//   "Motor"
					0x01, 					//  
					eSetValueWithOverwrite);//     

		vTaskDelay(pdMS_TO_TICKS(3000));
		xTaskNotify(pxMotor,
					0x00,
					eSetValueWithOverwrite);

	}
}//--------------------------------------------------------

/** @} */
/*==== END FILE =============================================================*/
