/** 
 * ******************************************************************************
 * \file		cm3_exept.c
 * \date		:  11 . 2019 .
 * \version		0.0a
 * \author		
 *
 * ----------------------------------------------------------------------------
 * \brief		   Cortex M3
 * \details		
 *
 * ******************************************************************************
 */

/** \brief    Cortex M3
 *
 */

/*--- [MCU header] ----------------------*/
#include "stm32f10x.h"

/*--- [System Level] --------------------*/


/*--- [Driver Level] --------------------*/


/*
 * ============================================================================
 *   Declarations
 * ============================================================================
 */
/*---------------------------------------------------------
 * 	[Types]
 */
/*---------------------------------------------------------
 * 	[Structs, Enums]
 */
/*---------------------------------------------------------
 *  [Defines]
 */
/*---------------------------------------------------------
 *  [Macros]
 */
/*---------------------------------------------------------
 *  [Private (static) variables]
 */
/*---------------------------------------------------------
 *  [Global variables]
 */
/*---------------------------------------------------------
 *  [External variables]
 */

/*
 *=============================================================================
 *
 *  Abstract: Cortex-M3 Processor Exceptions Handlers
 *
 *=============================================================================
*/
/** \addtogroup CM3_Exeptions
 * @{
 */

/**----------------------------------------------
  * @brief  This function handles NMI exception.
  */
void NMI_Handler(void)
{
}

/**----------------------------------------------
  * @brief  This function handles Hard Fault exception.
  */
void HardFault_Handler(void)
{
  while (1)
  {
	  NVIC_SystemReset();
  }
}

/**----------------------------------------------
  * @brief  This function handles Memory Manage exception.
  */
void MemManage_Handler(void)
{
  while (1)
  {
	  NVIC_SystemReset();
  }
}

/**----------------------------------------------
  * @brief  This function handles Bus Fault exception.
  */
void BusFault_Handler(void)
{
  while (1)
  {
	  NVIC_SystemReset();
  }
}

/**----------------------------------------------
  * @brief  This function handles Usage Fault exception.
  */
void UsageFault_Handler(void)
{
  while (1)
  {
	 NVIC_SystemReset();
  }
}

/**----------------------------------------------
  * @brief  This function handles SVCall exception.
  */
//void SVC_Handler(void)
//{
//}

/**----------------------------------------------
  * @brief  This function handles Debug Monitor exception.
  */
void DebugMon_Handler(void)
{
}

/**----------------------------------------------
  * @brief  This function handles PendSVC exception.
  */
//void PendSV_Handler(void)
//{
//}

/**----------------------------------------------
  * @brief  This function handles SysTick Handler.
  */
//void SysTick_Handler(void)
//{
//	//SwTimer_Callback();
//}//----------------------------------------------

/** @} */
/*============================= END FILE ====================================*/
